Stylistic changes to cheat (#97)

This commit is contained in:
Reto Kromer 2017-07-27 14:32:05 +02:00 committed by Alex Epstein
parent 1711e9e7a9
commit fcd658c842
1 changed files with 77 additions and 87 deletions

View File

@ -12,26 +12,25 @@ boundry=""
## This function determines which http get tool the system has installed and returns an error if there isnt one ## This function determines which http get tool the system has installed and returns an error if there isnt one
getConfiguredClient() getConfiguredClient()
{ {
if command -v curl &>/dev/null ; then if command -v curl &>/dev/null; then
configuredClient="curl" configuredClient="curl"
elif command -v wget &>/dev/null ; then elif command -v wget &>/dev/null; then
configuredClient="wget" configuredClient="wget"
elif command -v fetch &>/dev/null ; then elif command -v fetch &>/dev/null; then
configuredClient="fetch" configuredClient="fetch"
else else
echo "Error: This tool reqires either curl, wget, or fetch to be installed." echo "Error: This tool reqires either curl, wget, or fetch to be installed."
return 1 return 1
fi fi
} }
## Allows to call the users configured client without if statements everywhere ## Allows to call the users configured client without if statements everywhere
httpGet() httpGet()
{ {
case "$configuredClient" in case "$configuredClient" in
curl) curl -A curl -s "$@";; curl) curl -A curl -s "$@" ;;
wget) wget -qO- "$@";; wget) wget -qO- "$@" ;;
fetch) fetch -o "...";; fetch) fetch -o "..." ;;
esac esac
} }
@ -51,10 +50,10 @@ update()
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]];then if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]]; then
echo "Error: update utility has not been configured correctly." >&2 echo "Error: update utility has not been configured correctly." >&2
exit 1 exit 1
elif [[ $latestVersion == "" ]];then elif [[ $latestVersion == "" ]]; then
echo "Error: no active internet connection" >&2 echo "Error: no active internet connection" >&2
exit 1 exit 1
else else
@ -62,11 +61,11 @@ update()
echo "Version $latestVersion available" echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: " echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then if [[ "$answer" == [Yy] ]]; then
cd ~ || { echo 'Update Failed' ; exit 1 ; } cd ~ || { echo 'Update Failed'; exit 1; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; } git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1 ;} cd $repositoryName || { echo 'Update Failed'; exit 1; }
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit." git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine. chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1 ./$nameOfInstallFile "update" || exit 1
@ -84,33 +83,35 @@ update()
usage() usage()
{ {
echo "Cheat" cat <<EOF
echo "Description: Cheatsheets for quick information about multiple programming languages along with terminal commands" Cheat
echo "Usage: cheat [flags] [command] or cheat [flags] [programming language] [subject]" Description: Cheatsheets for quick information about multiple programming languages along with terminal commands
echo " -s Does a search for last argument rather than looking for exact match" Usage: cheat [flags] [command] or cheat [flags] [programming language] [subject]
echo " -i Case insensitive search" -s Does a search for last argument rather than looking for exact match
echo " -b Word boundaries in search" -i Case insensitive search
echo " -r Recursive search" -b Word boundaries in search
echo " -u Update Bash-Snippet Tools" -r Recursive search
echo " -h Show the help" -u Update Bash-Snippet Tools
echo " -v Get the tool version" -h Show the help
echo "Special Pages:" -v Get the tool version
echo " hello Describes building the hello world program written in the language" Special Pages:
echo " list This lists all cheatsheets related to previous arg if none it lists all cheatsheets" hello Describes building the hello world program written in the language
echo " learn Shows a learn-x-in-minutes language cheat sheet perfect for getting started with the language" list This lists all cheatsheets related to previous arg if none it lists all cheatsheets
echo " 1line A collection of one-liners in this language" learn Shows a learn-x-in-minutes language cheat sheet perfect for getting started with the language
echo " weirdness A collection of examples of weird things in this language" 1line A collection of one-liners in this language
echo "Examples:" weirdness A collection of examples of weird things in this language
echo " cheat rust hello" Examples:
echo " cheat -r -b -i go" cheat rust hello
echo " cheat julia Functions" cheat -r -b -i go
echo " cheat -i go operators" cheat julia Functions
cheat -i go operators
EOF
} }
getCheatSheet() getCheatSheet()
{ {
if [[ $# == 1 ]]; then if [[ $# == 1 ]]; then
if [[ $search == "1" ]];then if [[ $search == "1" ]]; then
link=cheat.sh/~$1 link=cheat.sh/~$1
else else
link=cheat.sh/$1 link=cheat.sh/$1
@ -119,15 +120,15 @@ getCheatSheet()
link=cheat.sh/$1 link=cheat.sh/$1
fi fi
if [[ $# == 2 ]];then if [[ $# == 2 ]]; then
if [[ $search == "1" ]];then if [[ $search == "1" ]]; then
link+=/~$2 ## add this to end of link where ~ indicates search link+=/~$2 ## add this to end of link where ~ indicates search
else else
link+=/$2 ## add this to end of link link+=/$2 ## add this to end of link
fi fi
fi fi
if [[ $insensitive != "" || $recursive != "" || $boundry != "" ]];then link+=/$boundry$insensitive$recursive; fi ## add this to the end of the link as flags if [[ $insensitive != "" || $recursive != "" || $boundry != "" ]]; then link+=/$boundry$insensitive$recursive; fi ## add this to the end of the link as flags
httpGet $link httpGet $link
} }
@ -137,14 +138,14 @@ getCheatSheet()
checkSpecialPage() checkSpecialPage()
{ {
temp=$1 temp=$1
if [[ $1 == "list" ]];then if [[ $1 == "list" ]]; then
temp=":list" temp=":list"
elif [[ $1 == "learn" ]];then elif [[ $1 == "learn" ]]; then
temp=":list" temp=":list"
elif [[ $1 == "styles" ]];then elif [[ $1 == "styles" ]]; then
temp=":styles" temp=":styles"
fi fi
if [[ $2 == "1" ]];then if [[ $2 == "1" ]]; then
arg1=$temp arg1=$temp
else else
arg2=$temp arg2=$temp
@ -155,53 +156,43 @@ getConfiguredClient || exit 1
checkInternet || exit 1 checkInternet || exit 1
while getopts "ribuvhis" opt; do while getopts "ribuvhis" opt; do
case $opt in case "$opt" in
\?) \?) echo "Invalid option: -$OPTARG" >&2
echo "Invalid option: -$OPTARG" >&2 exit 1
exit 1 ;;
;; h) usage
h) exit 0
usage ;;
exit 0 v) echo "Version $currentVersion"
;; exit 0
v) ;;
echo "Version $currentVersion" u) update
exit 0 exit 0
;; ;;
u) i) insensitive="i"
update search="1"
exit 0 ;;
;; b) boundry="b"
i) search="1"
insensitive="i" ;;
search="1" r) recursive="r"
;; search="1"
b) ;;
boundry="b" s) search="1"
search="1" ;;
;; :) echo "Option -$OPTARG requires an argument." >&2
r) exit 1
recursive="r" ;;
search="1"
;;
s)
search="1"
;;
:)
echo "Option -$OPTARG requires an argument." >&2
exit 1
;;
esac esac
done done
### This functions sets arg 1 and arg 2 to be unqique items after the options ### This functions sets arg 1 and arg 2 to be unqique items after the options
for arg for arg; do
do if [[ $arg != "-r" && $arg != "-s" && $arg != "-b" && $arg != "-i" ]]; then
if [[ $arg != "-r" && $arg != "-s" && $arg != "-b" && $arg != "-i" ]];then if [ -z ${arg1+x} ]; then
if [ -z ${arg1+x} ];then
arg1=$arg arg1=$arg
fi fi
if [ ! -z ${arg1+x} ];then if [ ! -z ${arg1+x} ]; then
arg2=$arg arg2=$arg
fi fi
fi fi
@ -214,14 +205,14 @@ checkSpecialPage $arg2 2
if [[ $# == 0 ]]; then if [[ $# == 0 ]]; then
usage usage
exit 0 exit 0
elif [[ $1 == "update" ]];then elif [[ $1 == "update" ]]; then
update update
exit 0 exit 0
elif [[ $1 == "help" || $1 == ":help" ]];then ## shows the help and prevents the user from seeing cheat.sh/:help elif [[ $1 == "help" || $1 == ":help" ]]; then ## shows the help and prevents the user from seeing cheat.sh/:help
usage usage
exit 0 exit 0
else else
if [[ $arg1 != $arg2 ]];then ## if they equal each other that means there was no arg 2 supplied if [[ $arg1 != $arg2 ]]; then ## if they equal each other that means there was no arg 2 supplied
getCheatSheet $arg1 $arg2 getCheatSheet $arg1 $arg2
exit 0 exit 0
else else
@ -229,5 +220,4 @@ else
exit 0 exit 0
fi fi
exit 0 exit 0
fi fi